// CRC32   ,  
// Proteus
// icq: 133575351  email:lawnmower-man@mail.ru 

#include<stdio.h>
#include<string.h>
#include<assert.h>

typedef unsigned long dword;
typedef unsigned char byte;

//  
enum{
POLYNOM32_ZIP        =0xEDB88320,	//(ZIP)
POLYNOM32_MPEG2      =0x04C11DB7,	//(MPEG2)
POLYNOM32_MPEG2_1    =0xEDB88320,
POLYNOM32_MPEG2_2    =0xDB710641,
POLYNOM32_IEEE       =0x04C11DB7, 	//(IEEE 802.3)
POLYNOM32_IEEE_1     =0xEDB88320,
POLYNOM32_IEEE_2     =0xDB710641,
POLYNOM32_CASTAGNOLI1=0x1EDC6F41,	//(Castagnoli)
POLYNOM32_CASTAGNOLI2=0x82F63B78,
POLYNOM32_Castagnoli3=0x05EC76F1,
POLYNOM32_KOOPMAN1   =0x741B8CD7,	//(Koopman)
POLYNOM32_KOOPMAN2   =0xEB31D82E
};




//!     
class CRC32 {
	dword crc32_table[256];
public:
	CRC32(dword polynom=POLYNOM32_ZIP);
	dword Calc(const byte*,int count);
};


CRC32::CRC32(dword polynom)
{
	int n,k; dword c;
	for(n=0;n<256;n++) {
		c=n;
		for(k=0;k<8;k++) c=c>>1^(-int(c&1)&polynom);
		crc32_table[n]=c;
	}
}

dword CRC32::Calc(const byte* data,int count)
{
	dword value=(dword)-1; 
	while(count--) value=(value>>8)^crc32_table[(byte)value^*data++]; 
	return value; 
}

//     (    5 )
dword _crc32(const byte *data,int count,dword polynom=POLYNOM32_ZIP) 
{
	int n;
	dword sum=(dword)-1;
	while(count--) {
		sum^=*data++;
		for(n=0;n<8;n++) sum=(-int(sum&1)&polynom)^(sum>>1);
	}
	return sum;
}



void main()
{
	assert(sizeof(int)==4);
	assert(sizeof(dword)==4 && sizeof(byte)==1);

	const byte data[]="3,1415926535897932384626433832795";
	CRC32 crc; dword res1,res2;
	res1=crc.Calc(data,strlen((char*)data));
	res2=_crc32(data,strlen((char*)data));
	if(res1!=0x615bc45a || res2!=0x615bc45a) printf("Internal error\n\a"),getchar();

	printf("done..\n");
}